package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFStepInst;
import com.sa.ibiz.demo.demo.service.WFStepInstService;
import com.sa.ibiz.demo.demo.service.dto.WFStepInstSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfstepinst")
public class WFStepInstResource
{
	@Autowired
	private WFStepInstService service;


	@PostMapping(value = "/update")
	public ResponseEntity<WFStepInst> update(@Validated @RequestBody WFStepInst data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤子实例[update]操作发生错误","WFStepInst",data.getWfstepinstid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFStepInst> getDraft(@Validated @RequestBody WFStepInst data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤子实例[getDraft]操作发生错误","WFStepInst","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFStepInst> checkKey(@Validated @RequestBody WFStepInst data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤子实例[checkKey]操作发生错误","WFStepInst",data.getWfstepinstid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFStepInst> remove(@Validated @RequestBody WFStepInst data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤子实例[remove]操作发生错误","WFStepInst",data.getWfstepinstid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFStepInst> create(@Validated @RequestBody WFStepInst data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流步骤子实例[create]操作发生错误","WFStepInst",data.getWfstepinstid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFStepInst> get(@Validated @PathVariable String id){
		WFStepInst data=new WFStepInst();
		data.setWfstepinstid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流步骤子实例[get]操作发生错误","WFStepInst",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFStepInst>> searchDefaultPage(@Validated @RequestBody WFStepInstSearchFilter filter){
		Page<WFStepInst> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFStepInst>> listDefault(@Validated @RequestBody WFStepInstSearchFilter filter){
		List<WFStepInst> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
